-- send table on "setsort" channel
--  exact match: { "mod:name", "color", true }
--  partial match: { "str", "color" }

local color = {
  grind = "blue",
  tools = "red",
  smelt = "green",
  next_sorter = "black",
  technology = "yellow",
}

local ITEM = { "currency", "red" }

local patterns = {
  { "currency", "red" },
  { "technic:raw_latex", "black", true },
  { "charcoal:charcoal_lump", "black", true },
  { "hazmat_suit", "red" },
  { "basic_materials:oil_extract", "green", true },
  { "basic_materials:paraffin", "green", true },
  { "technic:rubber_tree_grindings", "black", true },
  { "moretrees:rubber_tree_trunk", "blue", true },
  { "mesecon", "yellow" },
  { "3d_armor:", "red" },
  { "basic_materials:steel_bar", "red", true },
  { "basic_materials:padlock", "red", true },
  { "technic:granite", "black", true },
  { "unified_inventory:bag", "red" },
  { "vessels", "red" },
  { "mobs:nametag", "red", true },
  { "technic:gravel", "black", true },
  { "technic:marble", "black", true },
  { "default:mese", "yellow", true },
  { "default:mese_crystal_fragment", "yellow", true },
  { "default:mese_crystal", "yellow", true },
  { "digistuff:", "yellow" },
  { "screwdriver", "red" },
  { "pipeworks:", "yellow" },
  { "digiline:", "yellow" },
  { "technic", "yellow" }, -- some technic items need to be sent to black!
  { "mesecon:", "yellow" },
  { "ropes:", "red" },
  { "bucket", "red" },
  { "default:torch", "red", true },
  { "hoe", "red" },
  { "drill", "red" },
  { "pick", "red" },
  { "anvil", "red" },
  { "sword", "red" },
  { "shovel", "red" },
  { "axe", "red" },
  { "dust", "green" },
  { "lump", "blue" },
  { "default:coal_lump", "black", true },
}

if event.type == "program" and ITEM then
  digiline_send("setsort", ITEM)
elseif event.type == "digiline" and event.channel == "sorter" then
  mem.send = #patterns - 1
  digiline_send("setsort", patterns[#patterns])
  interrupt(1.2)
elseif event.type == "interrupt" then
  if mem.send > 0 then
    digiline_send("setsort", patterns[mem.send])
    mem.send = mem.send - 1
    interrupt(1.2)
  else
    digiline_send("status", true)
  end
end