-- send table on "setsort" channel
--  exact match: { "mod:name", "color", true }
--  partial match: { "str", "color" }

local color = {
  wood_products = "blue",
  food_products = "green",
  next_sorter = "black",
  trash = "yellow",
  plant_products = "red",
}

local ITEM = { "default:apple", "green", true }

local patterns = {
  { "default:apple", "green", true },
  { "ethereal:strawberry", "green", true },
  { "technic:rubber_tree_grindings", "black", true },
  { "wool", "red" },
  { "mobs:leather", "green", true },
  { "mobs:rabbit_hide", "green", true },
  { "default:dry_shrub", "red", true },
  { "flowers:", "red" },
  { "dye:", "red" },
  { "farming:", "green" },
  { "grass", "red" },
  { "mobs:mutton_raw", "green", true },
  { "basic_materials:paraffin", "blue", true },
  { "basic_materials:oil_extract", "blue", true },
  { "mobs:rabbit_raw", "green", true },
  { "technic:marble", "yellow", true },
  { "moreblocks:dirt_compressed", "yellow", true },
  { "moreblocks:cobble_compressed", "yellow", true },
  { "default:gravel", "yellow", true },
  { "default:sandstone", "yellow", true },
  { "default:silver_sand", "yellow", true },
  { "default:mossycoble", "yellow", true },
  { "technic:granite", "yellow", true },
  { "default:cobble", "yellow", true },
  { "default:sand", "yellow", true },
  { "default:dirt", "yellow", true },
  { "bush", "blue" },
  { "bonemeal", "green" },
  { "default:papyrus", "red", true },
  { "sapling", "blue" },
  { "leave", "blue" },
  { "wood", "blue" },
  { "tree", "blue" },
}

if event.type == "program" and ITEM then
  digiline_send("setsort", ITEM)
elseif event.type == "digiline" and event.channel == "sorter" then
  mem.send = #patterns - 1
  digiline_send("setsort", patterns[#patterns])
  interrupt(1.2)
elseif event.type == "interrupt" then
  if mem.send > 0 then
    digiline_send("setsort", patterns[mem.send])
    mem.send = mem.send - 1
    interrupt(1.2)
  else
    digiline_send("status", true)
  end
end