-- send table on "setsort" channel
--  exact match: { "mod:name", "color", true }
--  partial match: { "str", "color" }

if event.type == "item" then
  local item = event.item.name

  if mem.exact[item] then
    return mem.exact[item]
  else
    for str, color in pairs(mem.partial) do
      if string.find(item, str, 0, true) then
        return color
      end
    end
  end

  return "black"

elseif event.type == "digiline" and event.channel == "setsort" then
  local msg = event.msg

  if msg[3] then
    mem.exact[msg[1]] = msg[2]
  else
    mem.partial[msg[1]] = msg[2]
  end

elseif event.type == "program" then
  mem.exact = mem.exact or {}
  mem.partial = mem.partial or {}
end