-- {5, 7} count, value
local items = {
  {50, 7},
  {60, 3},
  {90, 10},
  {100, 20},
}

function centrifuge(what)
  local v = what
  if what[1] % 2 ~= 0 then print(v[1], v[2]) error('uneven') end
  local value = what[2]
  if value < 1 or value > 34 then print(v[1], v[2]) error('invalid') end

  local count = what[1] / 2
  local value1 = what[2] - 1
  local value2 = what[2] + 1
  return {count, value1}, {count, value2}
end

function sort(A, B)
  if A[1] == 35 then return false end
  --if A[1] == B[1] then
  --  return A[2] > B[2]
  --end
  return A[1] > B[1]
end

table.sort(items, sort)
for k,v in ipairs(items) do print(v[1], v[2]) end
--if true then return end

function grabeven(what)
  if what[1] % 2 == 0 then
    return what, nil
  else
    return {what[1]-1, what[2]}, {1, what[1]}
  end
end

function give(what)
  for k,v in ipairs(items) do
    if v[2] == what[2] then
      v[2] = v[2] + what[2]
      return
    end
  end
  table.insert(items, what)
end

table.sort(items, sort)
while items[1][1] > 1 and items[1][2] ~= 0 do
  local take, left = grabeven(table.remove(items, 1))
  local result1, result2 = centrifuge(take)
  give(result1)
  give(result2)
  if left then give(left) end

  table.sort(items, sort)
  --print("-")
  --for k,v in ipairs(items) do print(v[1], v[2]) end
end

for k,v in ipairs(items) do print(v[1], v[2]) end
