local t = 1.2

-- converts number to actual name
function name(value)
  if value == 7 then
    value = ""
  end
  return "technic:uranium"..tostring(value).."_dust"
end

-- reset on reprogramming
if event.type == "program" then
  mem.q = {}
  interrupt(t)

elseif event.type == "interrupt" then
  interrupt(t)

-- the first value in the queue is a tuple: how many are left to send and what value are they
-- for some reason we send an extra invalid piece of data for each tuple (an extra count with no value)
--  I believe this functions to delay the program! (yes it definitely does!)
  current = mem.q[1]
  if current then
    if current[1] > 0 then
      if current[2] then digiline_send("send", name(current[2])) end
      current[1] = current[1] - 1
    else
      table.remove(mem.q, 1)
    end
  end

-- when receiving a "request" message, we add it directly into the queue (it should be a tuple as defined above)
elseif event.type == "digiline" and event.channel == "request" then
  table.insert(mem.q, event.msg)

elseif event.type == "digiline" and event.channel == "abort" then
  mem.q = {}
  return
end