-- send table on "setsort" channel
--  exact match: { "mod:name", "color", true }
--  partial match: { "str", "color" }

local color = {
  construction = "yellow",
  ingots = "blue",
  digtron = "red",
  extract = "green",
}

local ITEM = { "concrete", "yellow" }

local patterns = {
  { "concrete", "yellow" },
  { "technic:rubber_tree_grindings", "green", true },
  { "digtron", "red" },
  { "chest", "yellow" },
  { "default:glass", "yellow", true },
  { "default:stonebrick", "yellow", true },
  { "itemframes", "yellow" },
  { "default:clay_brick", "yellow", true },
  { "stairs", "yellow" },
  { "bakedclay", "yellow" },
  { "default:brick", "yellow", true },
  { "default:furnace", "yellow", true },
  { "signs", "yellow" },
  { "homedecor", "yellow" },
  { "moreblocks", "yellow" },
  { "prefab", "yellow" },
  { "ingot", "blue" },
  { "factory_bridges", "yellow" },
}

if event.type == "program" and ITEM then
  digiline_send("setsort", ITEM)
elseif event.type == "digiline" and event.channel == "sorter" then
  mem.send = #patterns - 1
  digiline_send("setsort", patterns[#patterns])
  interrupt(1.2)
elseif event.type == "interrupt" then
  if mem.send > 0 then
    digiline_send("setsort", patterns[mem.send])
    mem.send = mem.send - 1
    interrupt(1.2)
  else
    digiline_send("status", true)
  end
end